%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Written by Justin Legleiter %
% For Use in:                 %
% 09-723 Proximal Probe Tech  %
% (c)2004                     %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% This code makes use of:
% Painless MATLAB GUIs for everybody
% (c) 2003, University of Cambridge
% Stefan Bleeck (stefan@bleeck.de)
% http://www.mrc-cbu.cam.ac.uk/cnbh/aimmanual/tools/parameter
% $Date: 2004/07/26$

function Problem_5(params)
global Kspring; global Bdamp; global Mtip;global Ncycles; global PtsPerCycle;
global Zstart; global Zprime; global Finitial; global Fres; global Phi
global Skippy; global Fres; global SimStep; global Nsteps; global SimTime;
global Npts; global PointMat;global Foper; global Drive 
%global ModParams
% check the number of inputs
if nargin==0 % initial call without parameters.
params=parameter('HarmonicOscillator'); % create an object of the parameter class with name
    % now we add some items to it:
params=add(params,'string','Kspring', 'YOUR')%textbox for entering Kspring
params=add(params,'string','Bdamp','HEAD')%textbox for entering Bdamp
params=add(params,'string','Mtip','A')%textbox for entering Mtip
params=add(params,'float','Ncycles',unit_none,25)%textbox for entering Ncycles
params=add(params,'float','PtsPerCycle',unit_none,64)%textbox for entering PtsPerCycle
params=add(params,'string','Zstart','SPLODE')%textbox for entering Zstart
params=add(params,'float','Zprime',unit_none,0)%textbox for entering Zprime
%params=add(params,'float','Fo',unit_none,0)%textbox for entering Drive
%params=add(params,'float','2pi * Foper',unit_none,0)%textbox for entering Fres
%params=add(params,'float','2pi * /phi',unit_none,0)%textbox for entering Phi

params=add(params,'button','Run Sim','Problem_5(params)')%Button to export parameters
params=add(params,'button','Take Points','TakeTrajPoints2')%Button to export parameters

    parametergui(params); % create the gui
    return  % and return to the shell. From now on the gui has the control 
end

% if we are here then we are called from the gui with the parameter
% structure in "params"

%creating paramter 
%Kspring=get(params,'Kspring');
%Bdamp=get(params,'Bdamp');
Kspring=0;
Bdamp=0;
Kspring=0;
Zstart=0;
%Mtip=get(params,'Mtip');
Ncycles=get(params,'Ncycles');
PtsPerCycle=get(params,'PtsPerCycle');
%Zstart=get(params,'Zstart');
Zprime=get(params,'Zprime');
Skippy= 5;
homeworkset
%Drive=get(params,'Fo');
%Foper=get(params,'2pi * Foper');
%Phi=get(params,'2pi * /phi');

%calculating parameters
Fres=((Kspring/Mtip)^0.5)/(2*pi);
SimStep = (1 / Fres) / PtsPerCycle;
Nsteps=(Ncycles-1)*PtsPerCycle;
SimTime=Nsteps*SimStep;
Npts = Nsteps + 1;

%run simulation
sim('HarmOscModel')%calling model
clear Traj;
%plotting results
Traj(1,:)=time';
Traj(2,:)=Ztraj';
figure (1)
set (gcf, 'NumberTitle','off');
set (gcf, 'name','Trajectory - Hero for Hire Inc.');
plot(Traj(1,:),Traj(2,:));
%axis([0 SimTime -abs(Zstart)-1e-9 abs(Zstart)+1e-9])
xlabel 'time (s)'
ylabel 'x (m)'
set(gcf,'Color', [1 1 1]);
homework_clear
